; *******************************************************
; *     CRT Interface Unit                              *
; *******************************************************

        TITLE   CRT

        INCLUDE SE.ASM

.8086

DATA    SEGMENT WORD PUBLIC

; Externals
        EXTRN   Seg0040:WORD

        extrn DelayCnt: dword
        extrn CRTLocal: byte ; Table of following:

include crt_save.inc

DATA    ENDS

CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE,DS:DATA

; Externals
        extrn CrtInit:near,CrtSetup:near,DelayLoop:near

; Publics
        PUBLIC  ClrScr,Delay,KeyPressed,ReadKey,TextMode

; Return true if key is available
KeyPressed:jmp dword ptr KeyPressedAddr

; Read character from keyboard
; Out   AL = Character
ReadKey:call dword ptr ReadKeyAddr
        retf

; Clear screen
ClrScr: jmp dword ptr ClrScrProcAddr

; Set CRT text mode
TextMode:MOV     BX,SP
        MOV     AX,SS:[BX+4]
        CALL    CrtInit
        CALL far ptr CrtSetup
        MOV     AL,NormAttr
        MOV     TextAttr,AL
        RETF    2

; Delay specified number of milliseconds
Delay:  MOV     BX,SP
        MOV     CX,SS:[BX+4]
        JCXZ    @@2
        MOV     ES,Seg0040
        XOR     DI,DI
        MOV     BL,ES:[DI]
@@1:    MOV     AX,DelayCnt.w0
        MOV     DX,DelayCnt.w2
        CALL    near ptr DelayLoop
        LOOP    @@1
@@2:    RETF    2

CODE    ENDS

        END
